Don't use dpdk dev packages - weekly, func and perf jobs
[csit.git] / bootstrap-verify-perf.sh
index a60b18d..e0a2e03 100755 (executable)
 set -x
 
 # Space separated list of available testbeds, described by topology files
-TOPOLOGIES="topologies/available/lf_testbed2-710-520.yaml"
-VPP_STABLE_VER="1.0.0-369~g106f0ed_amd64"
-VPP_REPO_URL="https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp"
+TOPOLOGIES="topologies/available/lf_testbed1.yaml \
+            topologies/available/lf_testbed2.yaml \
+            topologies/available/lf_testbed3.yaml"
+
+SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
 
 # Reservation dir
 RESERVATION_DIR="/tmp/reservation_dir"
 INSTALLATION_DIR="/tmp/install_dir"
 
-PYBOT_ARGS="--noncritical MULTI_THREAD"
+PYBOT_ARGS="-W 150"
+
+ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
 
 # If we run this script from CSIT jobs we want to use stable vpp version
 if [[ ${JOB_NAME} == csit-* ]] ;
 then
     mkdir vpp_download
     cd vpp_download
-    #download vpp build from nexus and set VPP_DEBS variable
-    wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}.deb" || exit
-    wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}.deb" || exit
-    wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}.deb" || exit
-    wget -q "${VPP_REPO_URL}/vpp-dpdk-dev/${VPP_STABLE_VER}/vpp-dpdk-dev-${VPP_STABLE_VER}.deb" || exit
-    wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${VPP_STABLE_VER}/vpp-dpdk-dkms-${VPP_STABLE_VER}.deb" || exit
-    wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}.deb" || exit
-    VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
-    PYBOT_ARGS="${PYBOT_ARGS} --exitonfailure"
+
+    if [[ ${TEST_TAG} == "PERFTEST_NIGHTLY" ]] ;
+    then
+        # Download the latest VPP build .deb install packages
+        echo Downloading VPP packages...
+        bash ${SCRIPT_DIR}/resources/tools/download_install_vpp_pkgs.sh --skip-install
+
+        VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
+        # Take vpp package and get the vpp version
+        VPP_STABLE_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
+    else
+        DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
+        VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
+        VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
+        VPP_CLASSIFIER="-deb"
+        # Download vpp build from nexus and set VPP_DEBS variable
+        wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-plugins/${VPP_STABLE_VER}/vpp-plugins-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
+    fi
+
     cd ..
 
 # If we run this script from vpp project we want to use local build
 elif [[ ${JOB_NAME} == vpp-* ]] ;
 then
-    #use local packages provided as argument list
+    # Use local packages provided as argument list
     # Jenkins VPP deb paths (convert to full path)
     VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
+    # Take vpp package and get the vpp version
+    VPP_STABLE_VER="$( expr match $1 'vpp-\(.*\)-deb.deb' )"
+    # Download DPDK parts not included in dpdk plugin of vpp build
+    DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
+    VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
+    VPP_CLASSIFIER="-deb"
+    wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+    VPP_DEBS+=($( readlink -f vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb ))
 else
     echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
     exit 1
 fi
 
-CUR_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
 WORKING_TOPOLOGY=""
-export PYTHONPATH=${CUR_DIR}
+export PYTHONPATH=${SCRIPT_DIR}
 
 sudo apt-get -y update
 sudo apt-get -y install libpython2.7-dev python-virtualenv
 
-virtualenv env
+virtualenv --system-site-packages env
 . env/bin/activate
 
 echo pip install
@@ -69,7 +96,7 @@ pip install -r requirements.txt
 while :; do
     for TOPOLOGY in ${TOPOLOGIES};
     do
-        python ${CUR_DIR}/resources/tools/topo_reservation.py -t ${TOPOLOGY}
+        python ${SCRIPT_DIR}/resources/tools/topo_reservation.py -t ${TOPOLOGY}
         if [ $? -eq 0 ]; then
             WORKING_TOPOLOGY=${TOPOLOGY}
             echo "Reserved: ${WORKING_TOPOLOGY}"
@@ -89,15 +116,15 @@ while :; do
 done
 
 function cancel_all {
-    python ${CUR_DIR}/resources/tools/topo_installation.py -c -d ${INSTALLATION_DIR} -t $1
-    python ${CUR_DIR}/resources/tools/topo_reservation.py -c -t $1
+    python ${SCRIPT_DIR}/resources/tools/topo_installation.py -c -d ${INSTALLATION_DIR} -t $1
+    python ${SCRIPT_DIR}/resources/tools/topo_reservation.py -c -t $1
 }
 
 # On script exit we cancel the reservation and installation and delete all vpp
 # packages
 trap "cancel_all ${WORKING_TOPOLOGY}" EXIT
 
-python ${CUR_DIR}/resources/tools/topo_installation.py -t ${WORKING_TOPOLOGY} \
+python ${SCRIPT_DIR}/resources/tools/topo_installation.py -t ${WORKING_TOPOLOGY} \
                                                        -d ${INSTALLATION_DIR} \
                                                        -p ${VPP_DEBS}
 if [ $? -eq 0 ]; then
@@ -110,47 +137,60 @@ fi
 case "$TEST_TAG" in
     # run specific performance tests based on jenkins job type variable
     PERFTEST_LONG )
-        pybot -L TRACE \
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -i perftest_long \
+              -s "tests.perf" \
+              --exclude SKIP_PATCH \
+              -i NDRPDRDISC \
               tests/
+        RETURN_STATUS=$(echo $?)
         ;;
     PERFTEST_SHORT )
-        pybot -L TRACE \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -i perftest_short \
-              tests/
-        ;;
-    PERFTEST_LONG_BRIDGE )
-        pybot -L TRACE \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s performance.long_bridge_domain \
-              tests/
-        ;;
-    PERFTEST_LONG_IPV4 )
-        pybot -L TRACE \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s performance.long_ipv4 \
-              tests/
-        ;;
-    PERFTEST_LONG_IPV6 )
-        pybot -L TRACE \
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s performance.long_ipv6 \
+              -s "tests.perf" \
+              -i NDRCHK \
               tests/
+        RETURN_STATUS=$(echo $?)
         ;;
-    PERFTEST_LONG_XCONNECT )
-        pybot -L TRACE \
+   PERFTEST_NIGHTLY )
+        #run all available tests
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s performance.long_xconnect \
+              -s "tests.perf" \
               tests/
+        RETURN_STATUS=$(echo $?)
         ;;
     * )
         # run full performance test suite and exit on fail
         pybot ${PYBOT_ARGS} \
               -L TRACE \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s performance \
+              -s "tests.perf" \
               tests/
+        RETURN_STATUS=$(echo $?)
 esac
 
+# Pybot output post-processing
+echo Post-processing test data...
+
+python ${SCRIPT_DIR}/resources/tools/robot_output_parser.py \
+       -i ${SCRIPT_DIR}/output.xml \
+       -o ${SCRIPT_DIR}/output_perf_data.xml \
+       -v ${VPP_STABLE_VER}
+if [ ! $? -eq 0 ]; then
+    echo "Parsing ${SCRIPT_DIR}/output.xml failed"
+fi
+
+# Archive artifacts
+mkdir archive
+for i in ${ARCHIVE_ARTIFACTS[@]}; do
+    cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
+done
+
+echo Post-processing finished.
+
+exit ${RETURN_STATUS}